#<profile4xi profile = "11" /> 
# -------------------------------------------------------------------------------------------------
#<program4xi program = "fire1800four4xi.py">
#<abstract4xi abstract = "fires to direction four and to distance 1800"/>
#<verify4xi verification = "11" target = "verb4xi.py"/>
#<refer4xi reference = "verb4xi.py"/>
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting; [Rel 7.21]"/>
# -------------------------------------------------------------------------------------------------

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'fire1800four4xi']
#"
#/>


# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
import os
import sys
import threading                
import _thread
import _winapi
   

import signal
import itertools
import weakref
import logging 

from math import pi
from math import sin
from math import cos 
from math import fabs
#"
#/>

# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "


from time4xi import time4xi

#"
#/>

       
# -------------------------------------------------------------------------------------------------
# SHOT2FOUR - COORDINATE SIGNS OF SHOOT2FOUR4XI: (X + ,Y - ,Z + )
# -------------------------------------------------------------------------------------------------    
global shot2four18004xi


#"
#/>

# -------------------------------------------------------------------------------------------------
# Settings
# -------------------------------------------------------------------------------------------------
#<set4xi setting = "
ack2debug = False
shot2four18004xi = {
                1:'1023x-248y1459z',
                2:'1035x-716y1286z',
                3:'1049x-1444y228z',
                4:'1049x-196y1449z',
                5:'1061x-1016y1039z',
                6:'106x-81y1794z',
                7:'1072x-143y1438z',
                8:'1082x-668y1273z',
                9:'1092x-88y1427z',
                10:'1110x-31y1416z',
                11:'1120x-965y1025z',
                12:'1125x-1389y210z',
                13:'1126x-617y1260z',
                14:'1168x-562y1247z',
                15:'1177x-912y1010z',
                16:'1197x-1329y192z',
                17:'1208x-505y1234z',
                18:'122x-345y1762z',
                19:'1232x-854y995z',
                20:'1244x-445y1221z',
                21:'125x-86y1793z',
                22:'1266x-1266y174z',
                23:'1277x-383y1208z',
                24:'1283x-794y980z',
                25:'1307x-318y1194z',
                26:'1332x-1199y156z',
                27:'1332x-730y965z',
                28:'1334x-252y1181z',
                29:'1357x-183y1167z',
                30:'1376x-113y1154z',
                31:'1377x-664y949z',
                32:'1392x-41y1140z',
                33:'1394x-1129y138z',
                34:'1418x-594y934z',
                35:'1452x-1055y120z',
                36:'145x-88y1791z',
                37:'146x-354y1758z',
                38:'1507x-978y102z',
                39:'1537x-552y970z',
                40:'1557x-898y84z',
                41:'1602x-816y66z',
                42:'1643x-731y48z',
                43:'165x-89y1790z',
                44:'1680x-644y30z',
                45:'1711x-556y12z',
                46:'172x-362y1754z',
                47:'183x-1744y405z',
                48:'186x-88y1788z',
                49:'199x-368y1750z',
                50:'207x-85y1785z',
                51:'227x-372y1746z',
                52:'228x-80y1783z',
                53:'249x-73y1781z',
                54:'256x-374y1741z',
                55:'270x-64y1778z',
                56:'274x-1736y387z',
                57:'286x-373y1737z',
                58:'290x-53y1775z',
                59:'294x-716y1624z',
                60:'310x-40y1772z',
                61:'317x-371y1732z',
                62:'329x-25y1769z',
                63:'338x-714y1616z',
                64:'348x-367y1727z',
                65:'348x-8y1765z',
                66:'366x-1723y370z',
                67:'379x-360y1722z',
                68:'383x-709y1609z',
                69:'410x-351y1717z',
                70:'428x-702y1600z',
                71:'442x-339y1711z',
                72:'456x-1704y352z',
                73:'473x-325y1705z',
                74:'473x-692y1592z',
                75:'480x-1016y1405z',
                76:'504x-309y1700z',
                77:'518x-679y1584z',
                78:'534x-290y1694z',
                79:'539x-1002y1394z',
                80:'546x-1681y334z',
                81:'563x-663y1575z',
                82:'564x-269y1687z',
                83:'593x-246y1681z',
                84:'598x-984y1382z',
                85:'608x-644y1566z',
                86:'621x-220y1675z',
                87:'634x-1654y317z',
                88:'647x-192y1668z',
                89:'652x-622y1557z',
                90:'657x-963y1371z',
                91:'664x-1236y1126z',
                92:'673x-161y1661z',
                93:'696x-597y1548z',
                94:'697x-129y1654z',
                95:'714x-938y1359z',
                96:'719x-94y1647z',
                97:'721x-1621y299z',
                98:'734x-1210y1112z',
                99:'738x-569y1539z',
                100:'739x-58y1639z',
                101:'758x-20y1632z',
                102:'771x-910y1347z',
                103:'780x-538y1529z',
                104:'802x-1179y1097z',
                105:'807x-1584y281z',
                106:'820x-505y1520z',
                107:'827x-878y1335z',
                108:'859x-468y1510z',
                109:'869x-1144y1083z',
                110:'882x-843y1323z',
                111:'890x-1541y263z',
                112:'895x-429y1500z',
                113:'91x-1747y422z',
                114:'931x-388y1490z',
                115:'934x-804y1311z',
                116:'935x-1105y1069z',
                117:'964x-343y1480z',
                118:'971x-1495y246z',
                119:'986x-762y1298z',
                120:'994x-297y1470z',
                121:'999x-1062y1054z'}
#"
#"/>
    

# -------------------------------------------------------------------------------------------------
#<function4xi function = "fire1800four4xi" usage = "target function for charge18004xi with Process4Xi">
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------
def fire1800four4xi(queue2four, consumer_channel2four, publisher_channel2four):
    '''
    returns (x,y,z) coordinates via queue
    '''
    
    # -------------------------------------------------------------------------------------------------
    # PARAMETERS                   
    # -------------------------------------------------------------------------------------------------                                                               
    
    time2start = time4xi()
    if ack2debug is True:
        print("\n (STEP 1A1/33) OF FIRE1800FOUR4XI - STARTED TIME: ", time2start)
        # 
        
        print("\n (STEP 1A2/33) OF FIRE1800FOUR4XI -  QUEUE2FOUR: ", queue2four)      
        # 
        
        print("\n (STEP 1A3/33) OF FIRE1800FOUR4XI -  CONSUMER_CHANNEL2FOUR: ", consumer_channel2four)
        # 
              
        print("\n (STEP 1A4/33) OF FIRE1800FOUR4XI -  PUBLISHER_CHANNEL2FOUR: ", publisher_channel2four)          
        # 
        


    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # QUEUE RETURNING
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    ack2put = False
    if ack2debug is True:
        print("\n (STEP 2A/33) OF FIRE1800FOUR4XI - TRYING TO RETURN BY PUTTING COORDINATE DICTIONARY TO QUEUE2FOUR: ", queue2four, " - TIME: ", time4xi()) 
        # 
         
    try:
        # ------------------------------------------------------------------------------------- 
        # PUT SHOT TO QUEUE 
        # -------------------------------------------------------------------------------------                 
        queue2four.put(shot2four18004xi)
        if ack2debug is True:
            print("\n (STEP 2B/33) OF FIRE1800FOUR4XI - SUCCEEDED TO PUT COORDINATE DICTIONARY TO QUEUE2FOUR: ", queue2four, " - TIME: ", time4xi()) 
            # 
             
        ack2put = True
    except:
        print("\n (STEP 2C/33) OF FIRE1800FOUR4XI *** FAILED TO PUT COORDINATE DICTIONARY TO QUEUE2FOUR: ", queue2four, " - TIME: ", time4xi()) 
    
    if ack2debug is True:
        print("\n (STEP 3A/33) OF FIRE1800FOUR4XI - TRYING TO INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER_CHANNEL2FOUR: ", publisher_channel2four, " - TIME: ", time4xi())
        # 
         
    try:                
        # ---------------------------------------------------------------------------------------------
        # INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER CHANNEL 
        # ---------------------------------------------------------------------------------------------
        if ack2put is True:
            message2send4one = "<ack2put4xi>queue2four8shot2four18004xi</ack2put4xi>"
        else:
            message2send4one = "<nack2put4xi>queue2four8shot2four18004xi</nack2put4xi>" 
            
        publisher_channel2four.send(message2send4one)
        if ack2debug is True:    
            print(" (STEP 3B/33) OF FIRE1800FOUR4XI -  SENT MESSAGE2SEND4ONE: ", message2send4one, " TO PUBLISHER_CHANNEL2FOUR: ", publisher_channel2four, " - TIME: ", time4xi()) 
            #  
        
    except:
        print(" (STEP 3C/33) OF FIRE1800FOUR4XI *** FAILED TO SEND MESSAGE2SEND4ONE: ", message2send4one, " TO PUBLISHER_CHANNEL2FOUR: ", publisher_channel2four, " - TIME: ", time4xi()) 
    
    if ack2debug is True:        
        print("\n (STEP 3D/33) OF FIRE1800FOUR4XI - RETURNING QUEUE OBJECT QUEUE2FOUR: ", queue2four, " - TIME: ", time4xi())  
        # 
            
    return queue2four    
        
           
#</function4xi>


#</program4xi>
# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#   test_verb4xi.txt
#   sense-test-verb4xi.xml
#   reason-test-verb4xi.xml
#   ace-test-verb4xi.xml
#"
#>



# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>
 

#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of fire1800four4xi.py                             
# ------------------------------------------------------------------------------------------------- 
#"
#/>
              
                      